Index: uspace/lib/c/arch/ia32/Makefile.common
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.common	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia32/Makefile.common	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -28,9 +28,5 @@
 
 CLANG_ARCH = i386
-ifeq ($(PROCESSOR),i486)
-GCC_CFLAGS += -march=i486 -fno-omit-frame-pointer
-else
 GCC_CFLAGS += -march=pentium -fno-omit-frame-pointer
-endif
 
 ENDIANESS = LE
Index: uspace/lib/c/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.inc	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia32/Makefile.inc	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -28,5 +28,5 @@
 
 ARCH_SOURCES = \
-	arch/$(UARCH)/src/entry.S \
+	arch/$(UARCH)/src/entry.s \
 	arch/$(UARCH)/src/entryjmp.s \
 	arch/$(UARCH)/src/thread_entry.s \
Index: uspace/lib/c/arch/ia32/src/entry.s
===================================================================
--- uspace/lib/c/arch/ia32/src/entry.s	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
+++ uspace/lib/c/arch/ia32/src/entry.s	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -0,0 +1,65 @@
+#
+# Copyright (c) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+INTEL_CPUID_STANDARD = 1
+INTEL_SEP = 11
+
+.section .init, "ax"
+
+.org 0
+
+.globl __entry
+
+## User-space task entry point
+#
+# %edi contains the PCB pointer
+#
+__entry:
+	mov %ss, %ax
+	mov %ax, %ds
+	mov %ax, %es
+	mov %ax, %fs
+	# Do not set %gs, it contains descriptor that can see TLS
+	
+	# Detect the mechanism used for making syscalls
+	movl $(INTEL_CPUID_STANDARD), %eax
+	cpuid
+	bt $(INTEL_SEP), %edx
+	jnc 0f
+	leal __syscall_fast_func, %eax
+	movl $__syscall_fast, (%eax)
+0:
+	#
+	# Create the first stack frame.
+	#
+	pushl $0
+	movl %esp, %ebp
+	
+	# Pass the PCB pointer to __main as the first argument
+	pushl %edi
+	call __main
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/async.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -112,5 +112,4 @@
 #include <mem.h>
 #include <stdlib.h>
-#include <macros.h>
 #include "private/async.h"
 
@@ -139,5 +138,5 @@
 	link_t link;
 	
-	task_id_t in_task_id;
+	sysarg_t in_task_hash;
 	atomic_t refcnt;
 	void *data;
@@ -151,6 +150,6 @@
 	link_t link;
 	
-	/** Incoming client task ID. */
-	task_id_t in_task_id;
+	/** Incoming client task hash. */
+	sysarg_t in_task_hash;
 	
 	/** Incoming phone hash. */
@@ -204,4 +203,10 @@
 }
 
+void *async_get_client_data(void)
+{
+	assert(fibril_connection);
+	return fibril_connection->client->data;
+}
+
 /** Default fibril function that gets called to handle new connection.
  *
@@ -284,10 +289,8 @@
 {
 	assert(key);
-	assert(keys == 2);
 	assert(item);
 	
 	client_t *client = hash_table_get_instance(item, client_t, link);
-	return (key[0] == LOWER32(client->in_task_id) &&
-	    (key[1] == UPPER32(client->in_task_id)));
+	return (key[0] == client->in_task_hash);
 }
 
@@ -577,91 +580,4 @@
 }
 
-static client_t *async_client_get(task_id_t client_id, bool create)
-{
-	unsigned long key[2] = {
-		LOWER32(client_id),
-		UPPER32(client_id),
-	};
-	client_t *client = NULL;
-
-	futex_down(&async_futex);
-	link_t *lnk = hash_table_find(&client_hash_table, key);
-	if (lnk) {
-		client = hash_table_get_instance(lnk, client_t, link);
-		atomic_inc(&client->refcnt);
-	} else if (create) {
-		client = malloc(sizeof(client_t));
-		if (client) {
-			client->in_task_id = client_id;
-			client->data = async_client_data_create();
-		
-			atomic_set(&client->refcnt, 1);
-			hash_table_insert(&client_hash_table, key, &client->link);
-		}
-	}
-
-	futex_up(&async_futex);
-	return client;
-}
-
-static void async_client_put(client_t *client)
-{
-	bool destroy;
-	unsigned long key[2] = {
-		LOWER32(client->in_task_id),
-		UPPER32(client->in_task_id)
-	};
-	
-	futex_down(&async_futex);
-	
-	if (atomic_predec(&client->refcnt) == 0) {
-		hash_table_remove(&client_hash_table, key, 2);
-		destroy = true;
-	} else
-		destroy = false;
-	
-	futex_up(&async_futex);
-	
-	if (destroy) {
-		if (client->data)
-			async_client_data_destroy(client->data);
-		
-		free(client);
-	}
-}
-
-void *async_get_client_data(void)
-{
-	assert(fibril_connection);
-	return fibril_connection->client->data;
-}
-
-void *async_get_client_data_by_id(task_id_t client_id)
-{
-	client_t *client = async_client_get(client_id, false);
-	if (!client)
-		return NULL;
-	if (!client->data) {
-		async_client_put(client);
-		return NULL;
-	}
-
-	return client->data;
-}
-
-void async_put_client_data_by_id(task_id_t client_id)
-{
-	client_t *client = async_client_get(client_id, false);
-
-	assert(client);
-	assert(client->data);
-
-	/* Drop the reference we got in async_get_client_data_by_hash(). */
-	async_client_put(client);
-
-	/* Drop our own reference we got at the beginning of this function. */
-	async_client_put(client);
-}
-
 /** Wrapper for client connection fibril.
  *
@@ -682,4 +598,6 @@
 	 */
 	fibril_connection = (connection_t *) arg;
+	
+	futex_down(&async_futex);
 	
 	/*
@@ -688,11 +606,30 @@
 	 * hash in a new tracking structure.
 	 */
-
-	client_t *client = async_client_get(fibril_connection->in_task_id, true);
-	if (!client) {
-		ipc_answer_0(fibril_connection->callid, ENOMEM);
-		return 0;
-	}
-
+	
+	unsigned long key = fibril_connection->in_task_hash;
+	link_t *lnk = hash_table_find(&client_hash_table, &key);
+	
+	client_t *client;
+	
+	if (lnk) {
+		client = hash_table_get_instance(lnk, client_t, link);
+		atomic_inc(&client->refcnt);
+	} else {
+		client = malloc(sizeof(client_t));
+		if (!client) {
+			ipc_answer_0(fibril_connection->callid, ENOMEM);
+			futex_up(&async_futex);
+			return 0;
+		}
+		
+		client->in_task_hash = fibril_connection->in_task_hash;
+		client->data = async_client_data_create();
+		
+		atomic_set(&client->refcnt, 1);
+		hash_table_insert(&client_hash_table, &key, &client->link);
+	}
+	
+	futex_up(&async_futex);
+	
 	fibril_connection->client = client;
 	
@@ -706,5 +643,22 @@
 	 * Remove the reference for this client task connection.
 	 */
-	async_client_put(client);
+	bool destroy;
+	
+	futex_down(&async_futex);
+	
+	if (atomic_predec(&client->refcnt) == 0) {
+		hash_table_remove(&client_hash_table, &key, 1);
+		destroy = true;
+	} else
+		destroy = false;
+	
+	futex_up(&async_futex);
+	
+	if (destroy) {
+		if (client->data)
+			async_client_data_destroy(client->data);
+		
+		free(client);
+	}
 	
 	/*
@@ -712,5 +666,5 @@
 	 */
 	futex_down(&async_futex);
-	unsigned long key = fibril_connection->in_phone_hash;
+	key = fibril_connection->in_phone_hash;
 	hash_table_remove(&conn_hash_table, &key, 1);
 	futex_up(&async_futex);
@@ -746,5 +700,5 @@
  * particular fibrils.
  *
- * @param in_task_id    Identification of the incoming connection.
+ * @param in_task_hash  Identification of the incoming connection.
  * @param in_phone_hash Identification of the incoming connection.
  * @param callid        Hash of the opening IPC_M_CONNECT_ME_TO call.
@@ -760,5 +714,5 @@
  *
  */
-fid_t async_new_connection(task_id_t in_task_id, sysarg_t in_phone_hash,
+fid_t async_new_connection(sysarg_t in_task_hash, sysarg_t in_phone_hash,
     ipc_callid_t callid, ipc_call_t *call,
     async_client_conn_t cfibril, void *carg)
@@ -772,5 +726,5 @@
 	}
 	
-	conn->in_task_id = in_task_id;
+	conn->in_task_hash = in_task_hash;
 	conn->in_phone_hash = in_phone_hash;
 	list_initialize(&conn->msg_queue);
@@ -831,5 +785,5 @@
 	case IPC_M_CONNECT_ME_TO:
 		/* Open new connection with fibril, etc. */
-		async_new_connection(call->in_task_id, IPC_GET_ARG5(*call),
+		async_new_connection(call->in_task_hash, IPC_GET_ARG5(*call),
 		    callid, call, client_connection, NULL);
 		return;
@@ -979,5 +933,5 @@
 {
 	if (!hash_table_create(&client_hash_table, CLIENT_HASH_TABLE_BUCKETS,
-	    2, &client_hash_table_ops))
+	    1, &client_hash_table_ops))
 		abort();
 	
@@ -1472,17 +1426,13 @@
 		return ENOENT;
 	
-	task_id_t task_id;
-	sysarg_t task_id_lo;
-	sysarg_t task_id_hi;
+	sysarg_t task_hash;
 	sysarg_t phone_hash;
 	int rc = async_req_3_5(exch, IPC_M_CONNECT_TO_ME, arg1, arg2, arg3,
-	    NULL, NULL, &task_id_lo, &task_id_hi, &phone_hash);
+	    NULL, NULL, NULL, &task_hash, &phone_hash);
 	if (rc != EOK)
 		return rc;
-
-	task_id = (task_id_t) MERGE_LOUP32(task_id_lo, task_id_hi);
 	
 	if (client_receiver != NULL)
-		async_new_connection(task_id, phone_hash, 0, NULL,
+		async_new_connection(task_hash, phone_hash, 0, NULL,
 		    client_receiver, carg);
 	
@@ -2479,37 +2429,4 @@
 }
 
-int async_state_change_start(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
-    sysarg_t arg3, async_exch_t *other_exch)
-{
-	return async_req_5_0(exch, IPC_M_STATE_CHANGE_AUTHORIZE,
-	    arg1, arg2, arg3, 0, other_exch->phone);
-}
-
-bool async_state_change_receive(ipc_callid_t *callid, sysarg_t *arg1,
-    sysarg_t *arg2, sysarg_t *arg3)
-{
-	assert(callid);
-
-	ipc_call_t call;
-	*callid = async_get_call(&call);
-
-	if (IPC_GET_IMETHOD(call) != IPC_M_STATE_CHANGE_AUTHORIZE)
-		return false;
-	
-	if (arg1)
-		*arg1 = IPC_GET_ARG1(call);
-	if (arg2)
-		*arg2 = IPC_GET_ARG2(call);
-	if (arg3)
-		*arg3 = IPC_GET_ARG3(call);
-
-	return true;
-}
-
-int async_state_change_finalize(ipc_callid_t callid, async_exch_t *other_exch)
-{
-	return ipc_answer_1(callid, EOK, other_exch->phone);
-}
-
 /** @}
  */
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/devman.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2007 Josef Cejka
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2009 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -195,5 +195,5 @@
 	
 	exch = devman_exchange_begin(DEVMAN_DRIVER);
-	async_connect_to_me(exch, 0, 0, 0, conn, NULL);
+	async_connect_to_me(exch, 0, 0, 0, NULL, NULL);
 	devman_exchange_end(exch);
 	
@@ -342,5 +342,5 @@
 }
 
-int devman_fun_get_handle(const char *pathname, devman_handle_t *handle,
+int devman_device_get_handle(const char *pathname, devman_handle_t *handle,
     unsigned int flags)
 {
@@ -383,132 +383,5 @@
 }
 
-static int devman_get_str_internal(sysarg_t method, sysarg_t arg1, char *buf,
-    size_t buf_size)
-{
-	async_exch_t *exch;
-	ipc_call_t dreply;
-	size_t act_size;
-	sysarg_t dretval;
-	
-	exch = devman_exchange_begin_blocking(LOC_PORT_CONSUMER);
-	
-	ipc_call_t answer;
-	aid_t req = async_send_1(exch, method, arg1, &answer);
-	aid_t dreq = async_data_read(exch, buf, buf_size - 1, &dreply);
-	async_wait_for(dreq, &dretval);
-	
-	devman_exchange_end(exch);
-	
-	if (dretval != EOK) {
-		async_wait_for(req, NULL);
-		return dretval;
-	}
-	
-	sysarg_t retval;
-	async_wait_for(req, &retval);
-	
-	if (retval != EOK)
-		return retval;
-	
-	act_size = IPC_GET_ARG2(dreply);
-	assert(act_size <= buf_size - 1);
-	buf[act_size] = '\0';
-	
-	return EOK;
-}
-
-int devman_fun_get_path(devman_handle_t handle, char *buf, size_t buf_size)
-{
-	return devman_get_str_internal(DEVMAN_FUN_GET_PATH, handle, buf,
-	    buf_size);
-}
-
-int devman_fun_get_name(devman_handle_t handle, char *buf, size_t buf_size)
-{
-	return devman_get_str_internal(DEVMAN_FUN_GET_NAME, handle, buf,
-	    buf_size);
-}
-
-static int devman_get_handles_once(sysarg_t method, sysarg_t arg1,
-    devman_handle_t *handle_buf, size_t buf_size, size_t *act_size)
-{
-	async_exch_t *exch = devman_exchange_begin_blocking(DEVMAN_CLIENT);
-
-	ipc_call_t answer;
-	aid_t req = async_send_1(exch, method, arg1, &answer);
-	int rc = async_data_read_start(exch, handle_buf, buf_size);
-	
-	devman_exchange_end(exch);
-	
-	if (rc != EOK) {
-		async_wait_for(req, NULL);
-		return rc;
-	}
-	
-	sysarg_t retval;
-	async_wait_for(req, &retval);
-	
-	if (retval != EOK) {
-		return retval;
-	}
-	
-	*act_size = IPC_GET_ARG1(answer);
-	return EOK;
-}
-
-/** Get list of handles.
- *
- * Returns an allocated array of handles.
- *
- * @param method	IPC method
- * @param arg1		IPC argument 1
- * @param data		Place to store pointer to array of handles
- * @param count		Place to store number of handles
- * @return 		EOK on success or negative error code
- */
-static int devman_get_handles_internal(sysarg_t method, sysarg_t arg1,
-    devman_handle_t **data, size_t *count)
-{
-	devman_handle_t *handles;
-	size_t act_size;
-	size_t alloc_size;
-	int rc;
-
-	*data = NULL;
-	act_size = 0;	/* silence warning */
-
-	rc = devman_get_handles_once(method, arg1, NULL, 0,
-	    &act_size);
-	if (rc != EOK)
-		return rc;
-
-	alloc_size = act_size;
-	handles = malloc(alloc_size);
-	if (handles == NULL)
-		return ENOMEM;
-
-	while (true) {
-		rc = devman_get_handles_once(method, arg1, handles, alloc_size,
-		    &act_size);
-		if (rc != EOK)
-			return rc;
-
-		if (act_size <= alloc_size)
-			break;
-
-		alloc_size *= 2;
-		free(handles);
-
-		handles = malloc(alloc_size);
-		if (handles == NULL)
-			return ENOMEM;
-	}
-
-	*count = act_size / sizeof(devman_handle_t);
-	*data = handles;
-	return EOK;
-}
-
-int devman_fun_get_child(devman_handle_t funh, devman_handle_t *devh)
+int devman_get_device_path(devman_handle_t handle, char *path, size_t path_size)
 {
 	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
@@ -516,16 +389,45 @@
 		return ENOMEM;
 	
-	sysarg_t retval = async_req_1_1(exch, DEVMAN_FUN_GET_CHILD,
-	    funh, devh);
-	
-	devman_exchange_end(exch);
-	return (int) retval;
-}
-
-int devman_dev_get_functions(devman_handle_t devh, devman_handle_t **funcs,
-    size_t *count)
-{
-	return devman_get_handles_internal(DEVMAN_DEV_GET_FUNCTIONS,
-	    devh, funcs, count);
+	ipc_call_t answer;
+	aid_t req = async_send_1(exch, DEVMAN_DEVICE_GET_DEVICE_PATH,
+	    handle, &answer);
+	
+	ipc_call_t data_request_call;
+	aid_t data_request = async_data_read(exch, path, path_size,
+	    &data_request_call);
+	
+	devman_exchange_end(exch);
+	
+	if (data_request == 0) {
+		async_wait_for(req, NULL);
+		return ENOMEM;
+	}
+	
+	sysarg_t data_request_rc;
+	async_wait_for(data_request, &data_request_rc);
+	
+	sysarg_t opening_request_rc;
+	async_wait_for(req, &opening_request_rc);
+	
+	if (data_request_rc != EOK) {
+		/* Prefer the return code of the opening request. */
+		if (opening_request_rc != EOK)
+			return (int) opening_request_rc;
+		else
+			return (int) data_request_rc;
+	}
+	
+	if (opening_request_rc != EOK)
+		return (int) opening_request_rc;
+	
+	/* To be on the safe-side. */
+	path[path_size - 1] = 0;
+	size_t transferred_size = IPC_GET_ARG2(data_request_call);
+	if (transferred_size >= path_size)
+		return ELIMIT;
+	
+	/* Terminate the string (trailing 0 not send over IPC). */
+	path[transferred_size] = 0;
+	return EOK;
 }
 
Index: uspace/lib/c/generic/event.c
===================================================================
--- uspace/lib/c/generic/event.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/event.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -54,10 +54,4 @@
 }
 
-int event_task_subscribe(event_task_type_t evno, sysarg_t imethod)
-{
-	return __SYSCALL2(SYS_EVENT_SUBSCRIBE, (sysarg_t) evno,
-	    (sysarg_t) imethod);
-}
-
 /** Unmask event notifications.
  *
@@ -72,9 +66,4 @@
 }
 
-int event_task_unmask(event_task_type_t evno)
-{
-	return __SYSCALL1(SYS_EVENT_UNMASK, (sysarg_t) evno);
-}
-
 /** @}
  */
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/io/io.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -101,8 +101,8 @@
 static LIST_INITIALIZE(files);
 
-void __stdio_init(int filc)
+void __stdio_init(int filc, fdi_node_t *filv[])
 {
 	if (filc > 0) {
-		stdin = fdopen(0, "r");
+		stdin = fopen_node(filv[0], "r");
 	} else {
 		stdin = &stdin_null;
@@ -111,5 +111,5 @@
 	
 	if (filc > 1) {
-		stdout = fdopen(1, "w");
+		stdout = fopen_node(filv[1], "w");
 	} else {
 		stdout = &stdout_klog;
@@ -118,5 +118,5 @@
 	
 	if (filc > 2) {
-		stderr = fdopen(2, "w");
+		stderr = fopen_node(filv[2], "w");
 	} else {
 		stderr = &stderr_klog;
@@ -285,4 +285,36 @@
 }
 
+FILE *fopen_node(fdi_node_t *node, const char *mode)
+{
+	int flags;
+	if (!parse_mode(mode, &flags))
+		return NULL;
+	
+	/* Open file. */
+	FILE *stream = malloc(sizeof(FILE));
+	if (stream == NULL) {
+		errno = ENOMEM;
+		return NULL;
+	}
+	
+	stream->fd = open_node(node, flags);
+	if (stream->fd < 0) {
+		/* errno was set by open_node() */
+		free(stream);
+		return NULL;
+	}
+	
+	stream->error = false;
+	stream->eof = false;
+	stream->klog = false;
+	stream->sess = NULL;
+	stream->need_sync = false;
+	_setvbuf(stream);
+	
+	list_append(&stream->link, &files);
+	
+	return stream;
+}
+
 int fclose(FILE *stream)
 {
@@ -748,10 +780,8 @@
 }
 
-int fhandle(FILE *stream, int *handle)
-{
-	if (stream->fd >= 0) {
-		*handle = stream->fd;
-		return EOK;
-	}
+int fnode(FILE *stream, fdi_node_t *node)
+{
+	if (stream->fd >= 0)
+		return fd_node(stream->fd, node);
 	
 	return ENOENT;
Index: uspace/lib/c/generic/io/printf_core.c
===================================================================
--- uspace/lib/c/generic/io/printf_core.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/io/printf_core.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -206,5 +206,5 @@
 	}
 	
-	return (int) (counter);
+	return (int) (counter + 1);
 }
 
@@ -244,5 +244,5 @@
 	}
 	
-	return (int) (counter);
+	return (int) (counter + 1);
 }
 
Index: uspace/lib/c/generic/libc.c
===================================================================
--- uspace/lib/c/generic/libc.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/libc.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -91,9 +91,9 @@
 		argc = 0;
 		argv = NULL;
-		__stdio_init(0);
+		__stdio_init(0, NULL);
 	} else {
 		argc = __pcb->argc;
 		argv = __pcb->argv;
-		__stdio_init(__pcb->filc);
+		__stdio_init(__pcb->filc, __pcb->filv);
 		(void) chdir(__pcb->cwd);
 	}
Index: uspace/lib/c/generic/loader.c
===================================================================
--- uspace/lib/c/generic/loader.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/loader.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -256,28 +256,38 @@
  *
  */
-int loader_set_files(loader_t *ldr, int * const files[])
-{
+int loader_set_files(loader_t *ldr, fdi_node_t *const files[])
+{
+	/*
+	 * Serialize the arguments into a single array. First
+	 * compute size of the buffer needed.
+	 */
+	fdi_node_t *const *ap = files;
+	size_t count = 0;
+	while (*ap != NULL) {
+		count++;
+		ap++;
+	}
+	
+	fdi_node_t *files_buf;
+	files_buf = (fdi_node_t *) malloc(count * sizeof(fdi_node_t));
+	if (files_buf == NULL)
+		return ENOMEM;
+	
+	/* Fill the buffer */
+	size_t i;
+	for (i = 0; i < count; i++)
+		files_buf[i] = *files[i];
+	
 	/* Send serialized files to the loader */
 	async_exch_t *exch = async_exchange_begin(ldr->sess);
-	async_exch_t *vfs_exch = vfs_exchange_begin();
-	
-	int i;
-	for (i = 0; files[i]; i++);
-
-	ipc_call_t answer;
-	aid_t req = async_send_1(exch, LOADER_SET_FILES, i, &answer);
-
-	sysarg_t rc = EOK;
-	
-	for (i = 0; files[i]; i++) {
-		rc = async_state_change_start(exch, VFS_PASS_HANDLE, *files[i],
-		    0, vfs_exch); 
-		if (rc != EOK)
-			break;
-	}
-	
-	vfs_exchange_end(vfs_exch);
-	async_exchange_end(exch);
-
+	
+	ipc_call_t answer;
+	aid_t req = async_send_0(exch, LOADER_SET_FILES, &answer);
+	sysarg_t rc = async_data_write_start(exch, (void *) files_buf,
+	    count * sizeof(fdi_node_t));
+	
+	async_exchange_end(exch);
+	free(files_buf);
+	
 	if (rc != EOK) {
 		async_wait_for(req, NULL);
Index: uspace/lib/c/generic/private/async.h
===================================================================
--- uspace/lib/c/generic/private/async.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/private/async.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -36,5 +36,4 @@
 #define LIBC_PRIVATE_ASYNC_H_
 
-#include <ipc/common.h>
 #include <adt/list.h>
 #include <fibril.h>
Index: uspace/lib/c/generic/private/io.h
===================================================================
--- uspace/lib/c/generic/private/io.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/private/io.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -36,5 +36,7 @@
 #define LIBC_PRIVATE_IO_H_
 
-extern void __stdio_init(int);
+#include <vfs/vfs.h>
+
+extern void __stdio_init(int filc, fdi_node_t *filv[]);
 extern void __stdio_done(void);
 
Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/task.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -46,5 +46,4 @@
 #include <libc.h>
 #include "private/ns.h"
-#include <vfs/vfs.h>
 
 task_id_t task_get_id(void)
@@ -103,21 +102,21 @@
 {
 	/* Send default files */
-	int *files[4];
-	int fd_stdin;
-	int fd_stdout;
-	int fd_stderr;
-	
-	if ((stdin != NULL) && (fhandle(stdin, &fd_stdin) == EOK))
-		files[0] = &fd_stdin;
+	fdi_node_t *files[4];
+	fdi_node_t stdin_node;
+	fdi_node_t stdout_node;
+	fdi_node_t stderr_node;
+	
+	if ((stdin != NULL) && (fnode(stdin, &stdin_node) == EOK))
+		files[0] = &stdin_node;
 	else
 		files[0] = NULL;
 	
-	if ((stdout != NULL) && (fhandle(stdout, &fd_stdout) == EOK))
-		files[1] = &fd_stdout;
+	if ((stdout != NULL) && (fnode(stdout, &stdout_node) == EOK))
+		files[1] = &stdout_node;
 	else
 		files[1] = NULL;
 	
-	if ((stderr != NULL) && (fhandle(stderr, &fd_stderr) == EOK))
-		files[2] = &fd_stderr;
+	if ((stderr != NULL) && (fnode(stderr, &stderr_node) == EOK))
+		files[2] = &stderr_node;
 	else
 		files[2] = NULL;
@@ -143,5 +142,5 @@
  */
 int task_spawnvf(task_id_t *id, const char *path, const char *const args[],
-    int *const files[])
+    fdi_node_t *const files[])
 {
 	/* Connect to a program loader. */
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -69,5 +69,5 @@
  *
  */
-async_exch_t *vfs_exchange_begin(void)
+static async_exch_t *vfs_exchange_begin(void)
 {
 	fibril_mutex_lock(&vfs_mutex);
@@ -87,5 +87,5 @@
  *
  */
-void vfs_exchange_end(async_exch_t *exch)
+static void vfs_exchange_end(async_exch_t *exch)
 {
 	async_exchange_end(exch);
@@ -329,4 +329,23 @@
 }
 
+int open_node(fdi_node_t *node, int oflag)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	
+	ipc_call_t answer;
+	aid_t req = async_send_4(exch, VFS_IN_OPEN_NODE, node->fs_handle,
+	    node->service_id, node->index, oflag, &answer);
+	
+	vfs_exchange_end(exch);
+
+	sysarg_t rc;
+	async_wait_for(req, &rc);
+	
+	if (rc != EOK)
+		return (int) rc;
+	
+	return (int) IPC_GET_ARG1(answer);
+}
+
 int close(int fildes)
 {
@@ -800,4 +819,18 @@
 }
 
+int fd_node(int fildes, fdi_node_t *node)
+{
+	struct stat stat;
+	int rc = fstat(fildes, &stat);
+	
+	if (rc == EOK) {
+		node->fs_handle = stat.fs_handle;
+		node->service_id = stat.service_id;
+		node->index = stat.index;
+	}
+	
+	return rc;
+}
+
 int dup2(int oldfd, int newfd)
 {
@@ -815,19 +848,4 @@
 }
 
-int fd_wait(void)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	
-	sysarg_t ret;
-	sysarg_t rc = async_req_0_1(exch, VFS_IN_WAIT_HANDLE, &ret);
-	
-	vfs_exchange_end(exch);
-	
-	if (rc == EOK)
-		return (int) ret;
-	
-	return (int) rc;
-}
-
 /** @}
  */
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/async.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -176,5 +176,5 @@
 extern int async_wait_timeout(aid_t, sysarg_t *, suseconds_t);
 
-extern fid_t async_new_connection(task_id_t, sysarg_t, ipc_callid_t,
+extern fid_t async_new_connection(sysarg_t, sysarg_t, ipc_callid_t,
     ipc_call_t *, async_client_conn_t, void *);
 
@@ -186,6 +186,4 @@
 extern void async_set_client_data_destructor(async_client_data_dtor_t);
 extern void *async_get_client_data(void);
-extern void *async_get_client_data_by_id(task_id_t);
-extern void async_put_client_data_by_id(task_id_t);
 
 extern void async_set_client_connection(async_client_conn_t);
@@ -479,10 +477,4 @@
 extern async_sess_t *async_callback_receive_start(exch_mgmt_t, ipc_call_t *);
 
-extern int async_state_change_start(async_exch_t *, sysarg_t, sysarg_t,
-    sysarg_t, async_exch_t *);
-extern bool async_state_change_receive(ipc_callid_t *, sysarg_t *, sysarg_t *,
-    sysarg_t *);
-extern int async_state_change_finalize(ipc_callid_t, async_exch_t *);
-
 #endif
 
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/devman.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -56,11 +56,7 @@
     unsigned int);
 
-extern int devman_fun_get_handle(const char *, devman_handle_t *,
+extern int devman_device_get_handle(const char *, devman_handle_t *,
     unsigned int);
-extern int devman_fun_get_child(devman_handle_t, devman_handle_t *);
-extern int devman_dev_get_functions(devman_handle_t, devman_handle_t **,
-    size_t *);
-extern int devman_fun_get_name(devman_handle_t, char *, size_t);
-extern int devman_fun_get_path(devman_handle_t, char *, size_t);
+extern int devman_get_device_path(devman_handle_t, char *, size_t);
 
 extern int devman_add_device_to_category(devman_handle_t, const char *);
Index: uspace/lib/c/include/event.h
===================================================================
--- uspace/lib/c/include/event.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/event.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -37,10 +37,7 @@
 
 #include <abi/ipc/event.h>
-#include <libarch/types.h>
 
 extern int event_subscribe(event_type_t, sysarg_t);
-extern int event_task_subscribe(event_task_type_t, sysarg_t);
 extern int event_unmask(event_type_t);
-extern int event_task_unmask(event_task_type_t);
 
 #endif
Index: uspace/lib/c/include/ipc/common.h
===================================================================
--- uspace/lib/c/include/ipc/common.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/ipc/common.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -39,5 +39,4 @@
 #include <abi/ipc/ipc.h>
 #include <atomic.h>
-#include <task.h>
 
 #define IPC_FLAG_BLOCKING  0x01
@@ -45,5 +44,5 @@
 typedef struct {
 	sysarg_t args[IPC_CALL_LEN];
-	task_id_t in_task_id;
+	sysarg_t in_task_hash;
 	sysarg_t in_phone_hash;
 } ipc_call_t;
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/ipc/devman.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -149,8 +149,5 @@
 typedef enum {
 	DEVMAN_DEVICE_GET_HANDLE = IPC_FIRST_USER_METHOD,
-	DEVMAN_DEV_GET_FUNCTIONS,
-	DEVMAN_FUN_GET_CHILD,
-	DEVMAN_FUN_GET_NAME,
-	DEVMAN_FUN_GET_PATH,
+	DEVMAN_DEVICE_GET_DEVICE_PATH,
 	DEVMAN_FUN_SID_TO_HANDLE
 } client_to_devman_t;
Index: uspace/lib/c/include/ipc/vfs.h
===================================================================
--- uspace/lib/c/include/ipc/vfs.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/ipc/vfs.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -62,4 +62,5 @@
 typedef enum {
 	VFS_IN_OPEN = IPC_FIRST_USER_METHOD,
+	VFS_IN_OPEN_NODE,
 	VFS_IN_READ,
 	VFS_IN_WRITE,
@@ -77,6 +78,5 @@
 	VFS_IN_RENAME,
 	VFS_IN_STAT,
-	VFS_IN_DUP,
-	VFS_IN_WAIT_HANDLE,
+	VFS_IN_DUP
 } vfs_in_request_t;
 
Index: uspace/lib/c/include/loader/loader.h
===================================================================
--- uspace/lib/c/include/loader/loader.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/loader/loader.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -38,4 +38,5 @@
 
 #include <task.h>
+#include <vfs/vfs.h>
 
 /** Forward declararion */
@@ -49,5 +50,5 @@
 extern int loader_set_pathname(loader_t *, const char *);
 extern int loader_set_args(loader_t *, const char *const[]);
-extern int loader_set_files(loader_t *, int *const[]);
+extern int loader_set_files(loader_t *, fdi_node_t *const[]);
 extern int loader_load_program(loader_t *);
 extern int loader_run(loader_t *);
Index: uspace/lib/c/include/loader/pcb.h
===================================================================
--- uspace/lib/c/include/loader/pcb.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/loader/pcb.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -38,4 +38,5 @@
 
 #include <sys/types.h>
+#include <vfs/vfs.h>
 
 typedef void (*entry_point_t)(void);
@@ -61,5 +62,7 @@
 	
 	/** Number of preset files. */
-	unsigned int filc;
+	int filc;
+	/** Preset files. */
+	fdi_node_t **filv;
 	
 	/*
Index: uspace/lib/c/include/task.h
===================================================================
--- uspace/lib/c/include/task.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/task.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -37,4 +37,5 @@
 
 #include <sys/types.h>
+#include <vfs/vfs.h>
 
 typedef uint64_t task_id_t;
@@ -52,5 +53,5 @@
 extern int task_spawnv(task_id_t *, const char *path, const char *const []);
 extern int task_spawnvf(task_id_t *, const char *path, const char *const [],
-    int *const []);
+    fdi_node_t *const []);
 extern int task_spawnl(task_id_t *, const char *path, ...);
 
